package net.minecraft.src.pwnedgod.wirelessstorage;

import net.minecraft.src.Container;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.ICrafting;
import net.minecraft.src.InventoryPlayer;
import net.minecraft.src.ItemStack;
import net.minecraft.src.Slot;

public class PG_ContainerStorage extends Container
{
	public PG_TileEntityWirelessStorage mainTEntity;
	public int energy = -1;
	
	public PG_ContainerStorage(InventoryPlayer playerInventory, PG_TileEntityWirelessStorage tEntity)
	{
		mainTEntity = tEntity;
		addSlot(new Slot(mainTEntity, 0, 152, 15));
		addSlot(new Slot(mainTEntity, 1, 152, 54));

		int j;
		for(j = 0; j < 3; j++) 
		{
			for(int k = 0; k < 9; k++) 
			{
				addSlot(new Slot(playerInventory, k + j * 9 + 9, 8 + k * 18, 84 + j * 18));
			}
		}

		for(j = 0; j < 9; ++j)
		{
	         addSlot(new Slot(playerInventory, j, 8 + j * 18, 142));
		}
	}
	
	public void updateCraftingResults()
	{
		super.updateCraftingResults();
		for(int i = 0; i < crafters.size(); ++i) {
	         ICrafting icrafting = (ICrafting)crafters.get(i);
	         if(energy != mainTEntity.energy) {
	        	 icrafting.updateCraftingInventoryInfo(this, 0, mainTEntity.energy & '\uffff');
	        	 icrafting.updateCraftingInventoryInfo(this, 1, mainTEntity.energy >>> 16);
	         }
	      }
		energy = mainTEntity.energy;
	}
	
	public ItemStack transferStackInSlot(int i) 
	{
		ItemStack is = null;
		Slot slot = getSlot(i);
		if(slot != null && slot.getHasStack()) 
		{
			ItemStack is1 = slot.getStack();
			is = is1.copy();
			if(i < guiInventorySize()) 
			{
				transferToSlots(is1, guiInventorySize(), inventorySlots.size(), false);
			} else if(i >= guiInventorySize() && i < inventorySlots.size() - 9) 
			{
				int j = getInput();
				if(j != -1 && j < guiInventorySize()) 
				{
	               transferToSlots(is1, j, j + 1, false);
	            } else 
	            {
	               transferToSlots(is1, 0, guiInventorySize(), false);
	            }
				} else if(i >= guiInventorySize() && i >= inventorySlots.size() - 9 && i < inventorySlots.size()) 
				{
					transferToSlots(is1, guiInventorySize(), inventorySlots.size() - 9, false);
				}
			if(is1.stackSize == 0) 
			{
				slot.putStack((ItemStack)null); 
			} else 
			{
				slot.onSlotChanged();
			}
			if(is1.stackSize == is.stackSize) 
			{
				return null;
			}
			slot.onPickupFromSlot(is1);
		}
		return is;
	}

	public void transferToSlots(ItemStack is, int startIndex, int endIndex, boolean lookBackwards) 
	{
		mergeItemStack(is, startIndex, endIndex, lookBackwards);
	}
	   
	public int guiInventorySize() 
	{
		return mainTEntity.getSizeInventory();
	}
	
	public int getInput() 
	{
		return mainTEntity.inputForItemToCharge.length;
	}
	
	public int getOutput()
	{
		return 0;
	}
	
	public void updateProgressBar(int i, int j)
	{
		switch(i) 
		{
		case 0:mainTEntity.energy = mainTEntity.energy & -65536 | j; break;
		case 1:mainTEntity.energy = mainTEntity.energy & '\uffff' | j << 16;
		}
	}
	
	public boolean canInteractWith(EntityPlayer entityplayer) 
	{
		return mainTEntity.isUseableByPlayer(entityplayer);
	}
}
