package net.minecraft.src.pwnedgod.wirelessstorage;

import java.util.LinkedList;
import java.util.List;
import org.lwjgl.opengl.GL11;
import net.minecraft.src.Container;
import net.minecraft.src.GuiButton;
import net.minecraft.src.GuiContainer;
import net.minecraft.src.mod_PGEU;
import net.minecraft.src.pwnedgod.Utils;

public class PG_GuiFrequency extends GuiContainer
{
	private GuiButton[] buttons = new GuiButton[7];
	public PG_TileEntityWirelessStorage mainTEntity;
	
	public PG_GuiFrequency(PG_TileEntityWirelessStorage tEntity) 
	{
		super(tEntity.emptyContainer);
		mainTEntity = tEntity;
		xSize = 227;
        ySize = 82;
	}

	public void initGui()
	{
		super.initGui();
		int bw = xSize - 20;
		int j = (width - xSize) / 2;
		int k = (height - ySize) / 2;
		controlList.add(buttons[0] = new GuiButton(1, j + 5, k + 5, bw / 6, 20, "-100"));
		controlList.add(buttons[1] = new GuiButton(2, j + 5, k + 30, bw / 6, 20, "-10"));
		controlList.add(buttons[2] = new GuiButton(3, j + 5, k + 55, bw / 6, 20, "-1"));
		controlList.add(buttons[3] = new GuiButton(4, j + 12 + bw / 6, k + 5, bw / 6, 20, "+1"));
		controlList.add(buttons[4] = new GuiButton(5, j + 12 + bw / 6, k + 30, bw / 6, 20, "+10"));
		controlList.add(buttons[5] = new GuiButton(6, j + 12 + bw / 6, k + 55, bw / 6, 20, "+100"));
		buttons[6] = new GuiButton(7, j + 5, k + 82, bw / 6, 35, "Set owner");
		if((mainTEntity.owner.equalsIgnoreCase("") || (mainTEntity.owner.startsWith("player")) && !mainTEntity.owner.equalsIgnoreCase(mod_PGEU.excludedName)))
		{
			controlList.add(buttons[6]);
		} else if(controlList.contains(buttons[6]))
		{
			controlList.remove(buttons[6]);
		}
	}
	
	public void actionPerformed(GuiButton guibutton)
	{
		int modifier = mainTEntity.freq;
		
		switch(guibutton.id)
		{
		case 1:modifier -= 100; break;
		case 2:modifier -= 10; break;
		case 3:modifier--; break;
		case 4:modifier++; break;
		case 5:modifier += 10; break;
		case 6:modifier += 100; break;
		case 7:mainTEntity.setOwnerFrom(mc.thePlayer); controlList.remove(buttons[6]);
		}
		if(guibutton.id != 7)
		{
			boolean positiveModifier = modifier > mainTEntity.freq;
			if(mainTEntity.sourceOfStorage)
			{
				checkAgain:
				{
					if(Utils.isOnServer() ? mainTEntity.flagFromFreq[modifier] : mainTEntity.isThereSourceOn(modifier))
					{
						if(positiveModifier) 
						{
							modifier++;
							break checkAgain;
						} else if (modifier == 0 && !positiveModifier)
						{
							modifier = mainTEntity.freq;
						} else
						{
							modifier--;
							break checkAgain;
						}
					}
				}
			}
			if(modifier < 0) 
			{
				modifier = 0;
			}
			if(modifier >= PG_TileEntityWirelessStorage.energyOnFreq.length) 
			{
				modifier = PG_TileEntityWirelessStorage.energyOnFreq.length - 1;
			}
			if(mainTEntity.sourceOfStorage && modifier != mainTEntity.freq)
			{
				PG_TileEntityWirelessStorage.energyOnFreq[modifier] = mainTEntity.energy;
				PG_TileEntityWirelessStorage.energyOnFreq[mainTEntity.freq] = 0;
			} else if(!mainTEntity.sourceOfStorage)
			{
				mainTEntity.energy = 0;
			}
			mainTEntity.freq = modifier;
		}
		if(Utils.isOnServer())
		{
			Utils.sendPacket(mainTEntity.sendGuiData());
		}
	}
	
	public void drawGuiContainerForegroundLayer()
	{
		fontRenderer.drawString("Frequency: " + mainTEntity.freq, 112, 14, 0xffffff);
		String tempStr = mainTEntity.getSharingStorages().size() == 1 ? " Sharing storage" : " Sharing storages";
		fontRenderer.drawString(mainTEntity.getSharingStorages().size() + tempStr, 112, 28, 0xffffff);
	    fontRenderer.drawString("Owner: " + mainTEntity.owner, 112, 42, 0xffffff);
	    fontRenderer.drawString(mainTEntity.sourceOfStorage ? "Source" : "Not source", 112, 56, 0xffffff);
	}
	
	public void drawGuiContainerBackgroundLayer(float f, int x, int y)
	{
		int i = mc.renderEngine.getTexture("/pwnedgod/wirelessstorage/textures/GUIFREQ.png");
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		mc.renderEngine.bindTexture(i);
		int j = (width - xSize) / 2;
		int k = (height - ySize) / 2;
		drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
		int hSize = 0;
		if((mainTEntity.owner.equalsIgnoreCase("") || (mainTEntity.owner.startsWith("player")) && !mainTEntity.owner.equalsIgnoreCase(mod_PGEU.excludedName)))
		{
			hSize = 72;
		} else
		{
			hSize = 0;
		}
		drawTexturedModalRect(j + 0, k + 79, 0, 82, hSize, 26);
	}
}
