package net.minecraft.src.pwnedgod.wirelessstorage;

import org.lwjgl.opengl.GL11;
import net.minecraft.src.Container;
import net.minecraft.src.EntityPlayerSP;
import net.minecraft.src.GuiButton;
import net.minecraft.src.GuiContainer;
import net.minecraft.src.InventoryPlayer;
import net.minecraft.src.TileEntity;
import net.minecraft.src.mod_PGEU;
import net.minecraft.src.ic2.api.NetworkHelper;
import net.minecraft.src.pwnedgod.Utils;

public class PG_GuiWirelessStorage extends GuiContainer
{
	public PG_TileEntityWirelessStorage mainTEntity;
	public PG_GuiFrequency freqGui;
	public PG_GuiRedstoneBehavior redstoneGui;

	public PG_GuiWirelessStorage(Container container) 
	{
		super(container);
		mainTEntity = ((PG_ContainerStorage)container).mainTEntity;
		freqGui = new PG_GuiFrequency(mainTEntity);
		redstoneGui = new PG_GuiRedstoneBehavior(mainTEntity);
	}
	
	public void initGui()
	{
		super.initGui();
		int j = (width - xSize) / 2;
		int k = (height - ySize) / 2;
		controlList.add(Utils.iconButton(1, j + 7, k + 4, 20, 20, "/pwnedgod/wirelessstorage/textures/GUIWS.png", 0, 166));
		controlList.add(Utils.iconButton(2, j + 7, k + 28, 20, 20, "/pwnedgod/wirelessstorage/textures/GUIWS.png", 16, 166));
		controlList.add(Utils.iconButton(3, j + 7, k + 52, 20, 20, "/pwnedgod/wirelessstorage/textures/GUIWS.png", 32, 166));
	}

	public void drawGuiContainerForegroundLayer()
	{
		fontRenderer.drawString(mod_PGEU.storageName, 48, 3, 0x404040);
		String freq = mainTEntity.freq > 999 ? "..." : ""+mainTEntity.freq;
		fontRenderer.drawString("Frequency: " + freq, 36, 14, 0xffffff);
		fontRenderer.drawString("Inventory", 8, (ySize - 96) + 2, 0x404040);
		
		int energy = mainTEntity.energy > mainTEntity.maxStorage ? mainTEntity.maxStorage : mainTEntity.energy;
		
		fontRenderer.drawString("Power Level:", 36, 26, 0xffffff);
		
		int color = energy == 0 ? 0x404040 : 0xffffff;
		
		fontRenderer.drawString("" + energy, 36, 38, color);
		fontRenderer.drawString("/" + mainTEntity.maxStorage, 36, 50, 0xffffff);
		fontRenderer.drawString("Out: " + mainTEntity.output + " EU/t", 36, 62, 0xffffff);
	}
	
	public void actionPerformed(GuiButton guibutton)
	{
		if(guibutton.id == 1) 
		{
			mc.thePlayer.openGui(Utils.getModInstance(mod_PGEU.class), mod_PGEU.freqGuiId, mainTEntity.worldObj, mainTEntity.xCoord, mainTEntity.yCoord, mainTEntity.zCoord);
		}
		if(guibutton.id == 2)
		{
			mainTEntity.outputTier++;
			if(mainTEntity.outputTier > PG_TileEntityWirelessStorage.aOutput.length - 1)
			{
				mainTEntity.outputTier = 0;
			}
			mainTEntity.output = mainTEntity.aOutput[mainTEntity.outputTier];
		}
		if(guibutton.id == 3) 
		{
			mc.thePlayer.openGui(Utils.getModInstance(mod_PGEU.class), mod_PGEU.behaviorGuiId, mainTEntity.worldObj, mainTEntity.xCoord, mainTEntity.yCoord, mainTEntity.zCoord);
		}
		if(Utils.isOnServer())
		{
			Utils.sendPacket(mainTEntity.sendGuiData());
		}
	}
	
	public void drawGuiContainerBackgroundLayer(float f, int x, int y)
    {
		int i = mc.renderEngine.getTexture("/pwnedgod/wirelessstorage/textures/GUIWS.png");
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		mc.renderEngine.bindTexture(i);
		int j = (width - xSize) / 2;
		int k = (height - ySize) / 2;
		drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
		if(mainTEntity.energy > 0)
        {
            int i1 = mainTEntity.gaugeEnergyScaled(24);
            drawTexturedModalRect(j + 121, k + 34, 176, 14, i1 + 1, 16);
        }
		int high1 = mainTEntity.isDischarging() ? 16 : 0;
		int high2 = mainTEntity.isCharging() ? 16 : 0;
		
		drawTexturedModalRect(j + 128, k + 51, 176, 31, 22, high1);
		drawTexturedModalRect(j + 128, k + 18, 176, 47, 22, high2);
    }
}
